' Script by Julio N.I.B.

Imports System ' basic imports
Imports GTA ' basic imports
Imports System.Windows.Forms ' needed to have access to "keys" enumeration, for example
Imports System.Drawing ' needed to handle colors referencing the color name, ex: myCar.color = System.Drawing.Color.Black

Public Class SimpleWallRide
    Inherits Script
	
	private bSOn as boolean = false
	private vecDirection as vector3
	
	private hkActivate, hkJump, hkBoost as int32
	private bCollisionProof as boolean
	private upForce, upSpeedLimit, upSpeedLimitAux, boostForce as double
	
	private timeScript as int16 = 0
	
    Public Sub New()
        Me.interval = 10
		
		' create the default settings
		If Settings.GetValueKey("hkActivate", "GENERAL", -1) = -1 Then Settings.SetValue("hkActivate", "GENERAL", keys.f4)
		If Settings.GetValueKey("hkJump", "GENERAL", -1) = -1 Then Settings.SetValue("hkJump", "GENERAL", keys.controlkey)
		If Settings.GetValueKey("hkBoost", "GENERAL", -1) = -1 Then Settings.SetValue("hkBoost", "GENERAL", keys.shiftkey)
		If Settings.GetValueString("bCollisionProof", "GENERAL", "") = "" Then Settings.SetValue("bCollisionProof", "GENERAL", "1")
		If Settings.GetValueString("upSpeedLimit", "GENERAL", "") = "" Then Settings.SetValue("upSpeedLimit", "GENERAL", "20")
		If Settings.GetValueString("boostForce", "GENERAL", "") = "" Then Settings.SetValue("boostForce", "GENERAL", "15")
		If Settings.GetValueString("upForce", "GENERAL", "") = "" Then Settings.SetValue("upForce", "GENERAL", "1")
		
		' load the settings
		hkActivate = Settings.GetValueKey("hkActivate", "GENERAL", keys.f4)
		hkJump = Settings.GetValueKey("hkJump", "GENERAL", keys.controlkey)
		hkBoost = Settings.GetValueKey("hkBoost", "GENERAL", keys.shiftkey)
		bCollisionProof = Settings.GetValueString("bCollisionProof", "GENERAL", "1") = "1"
		upSpeedLimit = Settings.GetValueFloat("upSpeedLimit", "GENERAL", 20.0)
		boostForce = Settings.GetValueFloat("boostForce", "GENERAL", 15.0)
		upForce = Settings.GetValueFloat("upForce", "GENERAL", 1.0)
		
		world.createvehicle("phantom", player.character.position.around(5))
    End Sub
	
	private sub msg(sMsg as string, time as int32)
		Native.Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", "STRING", sMsg, time, 1)
	end sub
	
    Private Sub keyDown(ByVal sender As Object, ByVal e As GTA.KeyEventArgs) Handles MyBase.KeyDown		
		' activates/deactivates the script
		if e.key = hkActivate then
			bSOn = not bSOn
			
			if bSOn then
				msg("Wall ride ON", 3000)
				
				if bCollisionProof then
					player.character.makeproofto(false, false, false, true, false)
					player.character.WillFlyThroughWindscreen = false
				end if
			else
				msg("Wall ride OFF", 3000)
				
				player.character.makeproofto(false, false, false, false, false)
				player.character.WillFlyThroughWindscreen = true
				if exists(player.character.currentvehicle) then player.character.currentvehicle.makeproofto(false, false, false, false, false)
			end if
		end if
		
		if bSOn andalso exists(player.character.currentvehicle) andalso player.character.isSittingInVehicle _
		   andalso (player.character.currentvehicle.model.isCar orelse player.character.currentvehicle.model.isBike) then
			' do the Jump, to help start the wall ride
			if (e.key = hkJump) andalso (player.character.currentvehicle.isonallwheels orelse player.character.currentvehicle.speed < 1) then
				' if its a large vehicle, like a truck/bus for ex., we apply more force up and less rotation
				if player.character.currentvehicle.model.getdimensions.y > 9 then
					player.character.currentvehicle.applyforce(vector3.worldup * 13, vector3.worldnorth / 1.5)
				' if its a smaller vehicle and not a bike, normal force and rotation
				elseif not player.character.currentvehicle.model.isbike then
					player.character.currentvehicle.applyforce(vector3.worldup * 10, vector3.worldnorth / 3)
				' if its a bike, less rotation
				else
					player.character.currentvehicle.applyforce(vector3.worldup * 10, vector3.worldnorth / 8)
				end if
				
				' resets the vector taht will determine the direction of the applyForce
				vecDirection = player.character.currentvehicle.direction
			end if
			
			' litle boost to increase "up" speed
			if (e.key = hkBoost) andalso (player.character.currentvehicle.rotation.x > 70) andalso (player.character.currentvehicle.rotation.x < 110) _
			   andalso (player.character.currentvehicle.model.isCar orelse player.character.currentvehicle.model.isBike) then
				player.character.currentvehicle.applyforce(vector3.worldup * boostForce)
			end if
		end if
    End Sub	
	Private Sub keyUp(ByVal sender As Object, ByVal e As GTA.KeyEventArgs) Handles MyBase.KeyUp
	end sub
		
	Private Sub general_tick(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Tick
		' automatically determines the direction if the vehicle its on ground
		if bSOn andalso exists(player.character.currentvehicle) andalso ((player.character.currentvehicle.rotation.x > -5) andalso (player.character.currentvehicle.rotation.x < 5)) then 
			' sets the vector taht will determine the direction of the applyForce
			vecDirection = player.character.currentvehicle.direction
		end if
		
		' do the effect (applyforce) when the player its accelerating and the vehicle its close to 90/-90 degrees
		if bSOn andalso exists(player.character.currentvehicle) andalso game.isgamekeypressed(gamekey.MoveForward) andalso _
		   (((player.character.currentvehicle.rotation.x > 70) andalso (player.character.currentvehicle.rotation.x < 110)) orelse _
		   ((player.character.currentvehicle.rotation.x > -110) andalso (player.character.currentvehicle.rotation.x < -70))) _
	       andalso (player.character.currentvehicle.model.isCar orelse player.character.currentvehicle.model.isBike) then		
			if not game.iskeypressed(hkBoost) then
				upSpeedLimitAux = upSpeedLimit
			else
				upSpeedLimitAux = 1000
			end if
			
			if (player.character.currentvehicle.speed <= upSpeedLimitAux) andalso (player.character.currentvehicle.rotation.x > 0) then
				player.character.currentvehicle.applyforce(vecDirection / 3 + (vector3.worldup / 2.5) * upForce)	
			elseif (player.character.currentvehicle.rotation.x > 0) then
				player.character.currentvehicle.applyforce(vecDirection / 3)	
			else
				player.character.currentvehicle.applyforce((vecDirection / 2 * -1) + vector3.worldup / 2)	
			end if
			
			' redefines the rotation of the vehicle only for bikes
			if player.character.currentvehicle.model.isbike andalso player.character.currentvehicle.isOnAllWheels then
				dim vecRot as vector3 = player.character.currentvehicle.rotation
				vecRot.x = 90
				player.character.currentvehicle.rotation = vecRot
			end if
		end if
		
		if bSon then
			timeScript += me.interval
			
			if timeScript > 1000 then 
				timeScript = 0
				
				if bCollisionProof andalso exists(player.character.currentvehicle) andalso (player.character.currentvehicle.model.isCar orelse player.character.currentvehicle.model.isBike) _
				   andalso not player.character.currentvehicle.metadata.isColProof then
					player.character.currentvehicle.makeproofto(false, false, false, true, false)
					player.character.currentvehicle.metadata.isColProof = true
				end if
			end if
		end if
	end sub			
End Class